Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDataCU.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDataCU.cpp	(revision 166)
@@ -49,4 +49,64 @@
 Int * TComDataCU::m_pcGlbArlCoeffCb = NULL;
 Int * TComDataCU::m_pcGlbArlCoeffCr = NULL;
+#endif
+
+#if FORCE_REF_VSP==1
+#define CHECK_ADD_YET(pcCURef,uiIdx) 
+#define SET_AOUND_MVINFO(pcCURef,uiIdx)  \
+{\
+  if((pcCURef)->isVspMode((uiIdx))){\
+    pcMvFieldNeighbours[iCount<<1].setRefIdx(getSlice()->getRefIdxVsp(REF_PIC_LIST_0));\
+    if(getSlice()->isInterB()){\
+      pcMvFieldNeighbours[(iCount<<1)+1].setRefIdx(getSlice()->getRefIdxVsp(REF_PIC_LIST_1));\
+    }\
+  }\
+}
+
+#elif FORCE_REF_VSP==2
+#define CHECK_ADD_YET(pcCURef,uiIdx)  &&!((pcCURef)->isVspMode((uiIdx),TComMv(0,0))&&bVspMvZeroDone)
+#define SET_AOUND_MVINFO(pcCURef,uiIdx)   if((pcCURef)->isVspMode((uiIdx),TComMv(0,0))){bVspMvZeroDone=true;}
+
+inline bool TComDataCU::xAddVspSkip(UChar ucVspMergePos, Bool bVspMvZeroDone, UInt uiDepth, Bool* abCandIsInter, Int& iCount,
+                                    UChar* puhInterDirNeighbours, TComMvField* pcMvFieldNeighbours, Int mrgCandIdx)
+{
+#if VSP_SLICE_HEADER
+  if( !getSlice()->getVspFlag() ) return true;
+#endif
+
+  if( ucVspMergePos == VSP_MERGE_POS )
+  {
+#if VSP_TEXT_ONLY
+    if( !getSlice()->getSPS()->isDepth() )
+#endif
+    if( getSlice()->getSPS()->getViewId()!=0 && !bVspMvZeroDone )
+    {
+      Bool bSubCUCanBeSynthesized[4];
+      Bool * pbSubCUCanBeSynthesized = bSubCUCanBeSynthesized;
+      getPic()->checkSynthesisAvailability( getAddr(), getZorderIdxInCU(), uiDepth, pbSubCUCanBeSynthesized );
+      if( bSubCUCanBeSynthesized[0] && bSubCUCanBeSynthesized[1] && bSubCUCanBeSynthesized[2] && bSubCUCanBeSynthesized[3] )
+      {
+        abCandIsInter[iCount] = true;
+        // get Inter Dir
+        Int iInterDir = ((getSlice()->getNumRefIdx(REF_PIC_LIST_0) > 0 && getSlice()->getNumRefIdx(REF_PIC_LIST_1) > 0) ? 3 :
+          (getSlice()->getNumRefIdx(REF_PIC_LIST_0) > 0 ? 1 : 2));
+        puhInterDirNeighbours[iCount] = iInterDir; //pcCUAboveLeft->getInterDir( uiAboveLeftPartIdx );
+        // get Mv from Left
+        pcMvFieldNeighbours[iCount<<1].setMvField( TComMv(0, 0), getSlice()->getRefIdxVsp(REF_PIC_LIST_0) ); //pcCUAboveLeft->getMvField( pcCUAboveLeft, uiAboveLeftPartIdx, REF_PIC_LIST_0, pcMvFieldNeighbours[iCount<<1] );
+        if ( getSlice()->isInterB() )
+        {
+          pcMvFieldNeighbours[(iCount<<1)+1].setMvField( TComMv(0, 0), getSlice()->getRefIdxVsp(REF_PIC_LIST_1) ); //pcCUAboveLeft->getMvField( pcCUAboveLeft, uiAboveLeftPartIdx, REF_PIC_LIST_1, pcMvFieldNeighbours[(iCount<<1)+1] );
+        }
+#if SIMP_MRG_PRUN
+        if ( mrgCandIdx == iCount )
+        {
+          return false;
+        }
+#endif
+        iCount ++;
+      }
+    }
+  }
+  return true;
+}
 #endif
 
@@ -3450,4 +3510,8 @@
 #endif
 
+#if FORCE_REF_VSP==2
+  bool bVspMvZeroDone = false;
+#endif
+
   Int iCount = 0;
 
@@ -3513,5 +3577,11 @@
 #endif
 
-  //left
+#if FORCE_REF_VSP==2
+  //===== vsp 0 ===== 
+  if ( !xAddVspSkip(0, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, mrgCandIdx) )
+    return;
+#endif
+
+  //===== left ===== 
   UInt uiLeftPartIdx = 0;
   TComDataCU* pcCULeft = 0;
@@ -3533,5 +3603,9 @@
   if (!(uiPUIdx == 1 && (partSize == SIZE_Nx2N || partSize == SIZE_nLx2N || partSize == SIZE_nRx2N)))
   {
-  if ( pcCULeft && !pcCULeft->isIntra( uiLeftPartIdx ) )
+  if ( pcCULeft && !pcCULeft->isIntra( uiLeftPartIdx )
+#if FORCE_REF_VSP
+    CHECK_ADD_YET(pcCULeft, uiLeftPartIdx)
+#endif
+  )
   {
     abCandIsInter[iCount] = true;
@@ -3548,4 +3622,7 @@
     pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
 #endif
+#if FORCE_REF_VSP
+    SET_AOUND_MVINFO(pcCULeft, uiLeftPartIdx)
+#endif
 #if SIMP_MRG_PRUN
     if ( mrgCandIdx == iCount )
@@ -3581,5 +3658,11 @@
 #endif
 
-  // above
+#if FORCE_REF_VSP==2
+  //===== vsp 1 ===== 
+  if ( !xAddVspSkip(1, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, mrgCandIdx) )
+    return;
+#endif
+
+  //===== above ===== 
 #if !SIMP_MRG_PRUN
   partSize = getPartitionSize( uiAbsPartIdx );
@@ -3605,4 +3688,7 @@
 #if SIMP_MRG_PRUN
   if ( pcCUAbove && !pcCUAbove->isIntra( uiAbovePartIdx ) 
+#if FORCE_REF_VSP
+    CHECK_ADD_YET(pcCUAbove, uiAbovePartIdx)
+#endif
     && !(uiPUIdx == 1 && (cCurPS == SIZE_2NxN || cCurPS == SIZE_2NxnU || cCurPS == SIZE_2NxnD))
     && ( !pcCULeft || pcCULeft->isIntra( uiLeftPartIdx ) || !pcCULeft->hasEqualMotion( uiLeftPartIdx, pcCUAbove, uiAbovePartIdx ) ) )
@@ -3624,4 +3710,7 @@
     pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
 #endif
+#if FORCE_REF_VSP
+    SET_AOUND_MVINFO(pcCUAbove, uiAbovePartIdx)
+#endif
 #if SIMP_MRG_PRUN
     if ( mrgCandIdx == iCount )
@@ -3659,5 +3748,11 @@
 #endif
 
-  // above right
+#if FORCE_REF_VSP==2
+  //===== vsp 2 =====
+  if ( !xAddVspSkip(2, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, mrgCandIdx) )
+    return;
+#endif
+
+  //===== above right =====
   UInt uiAboveRightPartIdx = 0;
   TComDataCU* pcCUAboveRight = 0;
@@ -3677,5 +3772,9 @@
 #endif
 #if SIMP_MRG_PRUN
-  if ( pcCUAboveRight && !pcCUAboveRight->isIntra( uiAboveRightPartIdx ) && ( !pcCUAbove || pcCUAbove->isIntra( uiAbovePartIdx ) || !pcCUAbove->hasEqualMotion( uiAbovePartIdx, pcCUAboveRight, uiAboveRightPartIdx ) ) )
+  if ( pcCUAboveRight && !pcCUAboveRight->isIntra( uiAboveRightPartIdx ) 
+#if FORCE_REF_VSP
+    CHECK_ADD_YET(pcCUAboveRight, uiAboveRightPartIdx)
+#endif
+    && ( !pcCUAbove || pcCUAbove->isIntra( uiAbovePartIdx ) || !pcCUAbove->hasEqualMotion( uiAbovePartIdx, pcCUAboveRight, uiAboveRightPartIdx ) ) )
 #else
   if ( pcCUAboveRight && !pcCUAboveRight->isIntra( uiAboveRightPartIdx ) )
@@ -3695,4 +3794,7 @@
     pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
 #endif
+#if FORCE_REF_VSP
+    SET_AOUND_MVINFO(pcCUAboveRight, uiAboveRightPartIdx)
+#endif
 #if SIMP_MRG_PRUN
     if ( mrgCandIdx == iCount )
@@ -3727,5 +3829,19 @@
 #endif
 
-  //left bottom
+#if FORCE_REF_VSP==2
+  //===== vsp 3 =====
+  if ( !xAddVspSkip(3, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, mrgCandIdx) )
+    return;
+#endif
+
+  //===== left bottom =====
+#if VSP_MERGE_POS < 4
+#if HHI_INTER_VIEW_MOTION_PRED
+  if( iCount < 4 + extraMergeCand )
+#else
+  if( iCount < 4 )
+#endif
+  {
+#endif
   UInt uiLeftBottomPartIdx = 0;
   TComDataCU* pcCULeftBottom = 0;
@@ -3745,5 +3861,9 @@
 #endif
 #if SIMP_MRG_PRUN
-  if ( pcCULeftBottom && !pcCULeftBottom->isIntra( uiLeftBottomPartIdx ) && ( !pcCULeft || pcCULeft->isIntra( uiLeftPartIdx ) || !pcCULeft->hasEqualMotion( uiLeftPartIdx, pcCULeftBottom, uiLeftBottomPartIdx ) ) )
+  if ( pcCULeftBottom && !pcCULeftBottom->isIntra( uiLeftBottomPartIdx ) 
+#if FORCE_REF_VSP
+    CHECK_ADD_YET(pcCULeftBottom, uiLeftBottomPartIdx)
+#endif
+    && ( !pcCULeft || pcCULeft->isIntra( uiLeftPartIdx ) || !pcCULeft->hasEqualMotion( uiLeftPartIdx, pcCULeftBottom, uiLeftBottomPartIdx ) ) )
 #else
   if ( pcCULeftBottom && !pcCULeftBottom->isIntra( uiLeftBottomPartIdx ) )
@@ -3763,4 +3883,7 @@
     pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
 #endif
+#if FORCE_REF_VSP
+    SET_AOUND_MVINFO(pcCULeftBottom, uiLeftBottomPartIdx)
+#endif
 #if SIMP_MRG_PRUN
     if ( mrgCandIdx == iCount )
@@ -3771,4 +3894,7 @@
     iCount ++;
   }
+#if VSP_MERGE_POS < 4
+  }
+#endif
 
 #if HHI_INTER_VIEW_MOTION_PRED
@@ -3795,5 +3921,14 @@
 #endif
 
-  // above left 
+#if FORCE_REF_VSP==2
+  //===== vsp 4 =====
+  if( iCount < 4 + extraMergeCand )
+  {
+    if ( !xAddVspSkip(4, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, mrgCandIdx) )
+      return;
+  }
+#endif
+
+  //===== above left =====
 #if HHI_INTER_VIEW_MOTION_PRED
   if( iCount < 4 + extraMergeCand )
@@ -3820,4 +3955,7 @@
 #if SIMP_MRG_PRUN
     if( pcCUAboveLeft && !pcCUAboveLeft->isIntra( uiAboveLeftPartIdx )
+#if FORCE_REF_VSP
+     CHECK_ADD_YET(pcCUAboveLeft, uiAboveLeftPartIdx)
+#endif
      && ( !pcCULeft || pcCULeft->isIntra( uiLeftPartIdx ) || !pcCULeft->hasEqualMotion( uiLeftPartIdx, pcCUAboveLeft, uiAboveLeftPartIdx ) )
      && ( !pcCUAbove || pcCUAbove->isIntra( uiAbovePartIdx ) || !pcCUAbove->hasEqualMotion( uiAbovePartIdx, pcCUAboveLeft, uiAboveLeftPartIdx ) )
@@ -3840,4 +3978,7 @@
       pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
 #endif
+#if FORCE_REF_VSP
+      SET_AOUND_MVINFO(pcCUAboveLeft, uiAboveLeftPartIdx)
+#endif
 #if SIMP_MRG_PRUN
       if ( mrgCandIdx == iCount )
@@ -3849,4 +3990,17 @@
     }
   }
+
+#if FORCE_REF_VSP==2
+  //===== vsp 5 =====
+#if HHI_INTER_VIEW_MOTION_PRED
+  if( iCount < 4 + extraMergeCand )
+#else
+  if( iCount < 4 )
+#endif
+  {
+    if ( !xAddVspSkip(5, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, mrgCandIdx) )
+      return;
+  }
+#endif
 
   if ( getSlice()->getPPS()->getEnableTMVPFlag() )
@@ -4268,5 +4422,9 @@
   if( uiIter == 0 )
   {
-    if( pcCorner && !pcCorner->isIntra( uiCornerPUIdx ) )
+    if( pcCorner && !pcCorner->isIntra( uiCornerPUIdx ) 
+#if FORCE_REF_VSP==1
+     && !pcCorner->isVspMode( uiCornerPUIdx )
+#endif
+    )
     {
       rbValidCand = true;
@@ -4303,5 +4461,9 @@
   else
   {
-    if( pcCorner && !pcCorner->isIntra( uiCornerPUIdx ) )
+    if( pcCorner && !pcCorner->isIntra( uiCornerPUIdx ) 
+#if FORCE_REF_VSP==1
+     && !pcCorner->isVspMode( uiCornerPUIdx )
+#endif
+    )
     {
       rbValidCand = true;
@@ -4452,4 +4614,7 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
+#if VSP_N
+  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
+#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -4478,4 +4643,7 @@
 
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
+#if VSP_N
+  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
+#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -4504,4 +4672,7 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
+#if VSP_N
+  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
+#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -4529,4 +4700,7 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
+#if VSP_N
+  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
+#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -4557,4 +4731,7 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
+#if VSP_N
+  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
+#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -4768,5 +4945,5 @@
   UInt uiNumPartInCUWidth = m_pcPic->getNumPartInWidth();
 
-  Int   aiDvMcpDvCand[2][7] = {{0,},    {0,}}; // dummy, 5 spatial + 1 temporal, DV-MCP ÁÖº¯ ºí·°¿¡¼­ »ç¿ëµÈ DV¸¦ ÀúÀå
+  Int   aiDvMcpDvCand[2][7] = {{0,},    {0,}}; // dummy, 5 spatial + 1 temporal, DV-MCP ÁÖº¯ ºúÓ°¿¡¼­ »ç¿EÈ DV¸¦ ÀúÀE
   Bool  abDvMcpFlag  [2][7] = {{false,},{false,}}; 
   //Int   aiRefPOC     [2][7] = {{-1,},{-1}}; // debug
@@ -4788,4 +4965,7 @@
   UInt uiLeftPartIdx = uiIdx;
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
+#if VSP_N
+  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
+#endif
   {
     bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
@@ -4826,4 +5006,7 @@
 
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
+#if VSP_N
+  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
+#endif
   {
     bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
@@ -4863,4 +5046,7 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
+#if VSP_N
+  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
+#endif
   {
     bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
@@ -4900,4 +5086,7 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
+#if VSP_N
+  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
+#endif
   {
     bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
@@ -4939,4 +5128,7 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
+#if VSP_N
+  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
+#endif
   {
     bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
@@ -5551,4 +5743,65 @@
 }
 
+#if FORCE_REF_VSP==2
+Int TComDataCU::isVspMode ( UInt uiPartIdx )
+{
+  if( m_pePredMode[ uiPartIdx ] == MODE_SKIP  ) return 0;
+  if( m_pePredMode[ uiPartIdx ] == MODE_INTRA ) return 0;
+
+  Int aiRefIdx[2] = {NOT_VALID, NOT_VALID}, iRet = 0;
+  for( Int iList = 0; iList < 2; iList++ )
+  {
+    aiRefIdx[iList] = getCUMvField( RefPicList(iList) )->getRefIdx( uiPartIdx );
+    if( aiRefIdx[iList] >= 0 && getSlice()->getRefViewId( RefPicList(iList), aiRefIdx[iList] ) == NUM_VIEW_VSP )
+    {
+      iRet |= (iList ? 0x02 : 0x01); // L0=1, L1=2, BI=3
+      continue;
+    }
+  }
+
+  return iRet; 
+}
+
+Int TComDataCU::isVspMode ( UInt uiPartIdx, TComMv cCompMv )
+{
+  TComMv cMv;
+  Int iRet = 0, iList = 0;
+
+  if( (iList = isVspMode( uiPartIdx )) )
+  {
+    switch( iList )
+    {
+    case 1:
+      cMv = getCUMvField( RefPicList(0) )->getMv( uiPartIdx );
+      if( cMv == cCompMv )
+      {
+        iRet = 1; // L0=1
+      }
+      break;
+    case 2:
+      cMv = getCUMvField( RefPicList(1) )->getMv( uiPartIdx );
+      if( cMv == cCompMv )
+      {
+        iRet = 2; // L1=2
+      }
+      break;
+    case 3:
+      cMv = getCUMvField( RefPicList(0) )->getMv( uiPartIdx );
+      if( cMv == cCompMv )
+      {
+        cMv = getCUMvField( RefPicList(1) )->getMv( uiPartIdx );
+        if( cMv == cCompMv )
+        {
+          iRet = 3; // BI=3
+        }
+      }
+      break;
+    }
+  }
+
+  return iRet; 
+}
+#endif
+
 // ====================================================================================================================
 // Protected member functions
@@ -5612,4 +5865,11 @@
   }
  
+#if AMVP_VSP_UNAVAILABLE
+  if( pcTmpCU != NULL && pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) >= 0 && pcTmpCU->getSlice()->getRefViewId( eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ) == NUM_VIEW_VSP )
+  {
+    return false;
+  }
+#endif
+
   if ( pcTmpCU != NULL && m_pcSlice->isEqualRef(eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx), iRefIdx) )
   {
@@ -5713,4 +5973,7 @@
   TComDataCU* pcTmpCU = NULL;
   UInt uiIdx;
+#if VSP_N
+  Bool bRefVsp = false;
+#endif
   switch( eDir )
   {
@@ -5770,4 +6033,11 @@
     return false;
   }
+
+#if AMVP_VSP_UNAVAILABLE
+  if( pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) >= 0 && pcTmpCU->getSlice()->getRefViewId( eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ) == NUM_VIEW_VSP )
+  {
+    return false;
+  }
+#endif
   
   RefPicList eRefPicList2nd = REF_PIC_LIST_0;
@@ -5815,5 +6085,13 @@
     }
 
+#if VSP_N
+    if( pcTmpCU->getSlice()->getRefViewId( eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ) == NUM_VIEW_VSP )
+    {
+      bRefVsp = true;
+    }
+    Int iScale = bRefVsp ? 4096 : xGetDistScaleFactor( iCurrPOC, iCurrRefPOC, iNeibPOC, iNeibRefPOC );
+#else
     Int iScale = xGetDistScaleFactor( iCurrPOC, iCurrRefPOC, iNeibPOC, iNeibRefPOC );
+#endif
     if ( iScale == 4096 )
     {
@@ -5842,5 +6120,13 @@
     }
 
+#if VSP_N
+    if( pcTmpCU->getSlice()->getRefViewId( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx) ) == NUM_VIEW_VSP )
+    {
+      bRefVsp = true;
+    }
+    Int iScale = bRefVsp ? 4096 : xGetDistScaleFactor( iCurrPOC, iCurrRefPOC, iNeibPOC, iNeibRefPOC );
+#else
     Int iScale = xGetDistScaleFactor( iCurrPOC, iCurrRefPOC, iNeibPOC, iNeibRefPOC );
+#endif
     if ( iScale == 4096 )
     {
@@ -5875,7 +6161,23 @@
   Int iColViewIdx, iColRefViewIdx;
   TComPic *pColPic = getSlice()->getRefPic( eRefPicList, refidx);
+#if VSP_MV_ZERO // shimizu
   TComDataCU *pColCU = pColPic->getCU( uiCUAddr );
   iColViewIdx = pColCU->getSlice()->getViewId();
-
+#if VSP_N
+  if( iColViewIdx == NUM_VIEW_VSP )
+  {
+    return false;
+  }
+#endif
+#else  
+#if VSP_N
+  if( pColPic->getSlice(0)->getViewId() == NUM_VIEW_VSP )
+  {
+    return false;
+  }
+#endif
+  TComDataCU *pColCU = pColPic->getCU( uiCUAddr );
+  iColViewIdx = pColCU->getSlice()->getViewId();
+#endif
 
   if (pColCU->getPic()==0||pColCU->getPartitionSize(uiPartUnitIdx)==SIZE_NONE||pColCU->isIntra(uiAbsPartAddr))
@@ -5904,4 +6206,10 @@
 
     iColRefViewIdx = pColCU->getSlice()->getRefPic(eColRefPicList, iColRefIdx)->getViewId();
+#if VSP_N
+    if( iColRefViewIdx == NUM_VIEW_VSP )
+    {
+      continue;
+    }
+#endif
 
     if ( iColViewIdx    == iColRefViewIdx ) // temporal vector
@@ -6040,4 +6348,11 @@
   iScale = 0;
   iCurrRefViewOrderIdx = m_pcSlice->getRefPic(eRefPicList, riRefIdx)->getViewOrderIdx();
+#if VSP_N
+//  UInt uiColRefViewId = pColCU->getSlice()->getRefPic( eColRefPicList, pColCU->getCUMvField(eColRefPicList)->getRefIdx(uiAbsPartAddr))->getViewId();
+  UInt uiCurRefViewId = m_pcSlice->getRefPic(eRefPicList, riRefIdx)->getViewId();
+  if( uiCurRefViewId == NUM_VIEW_VSP )
+    iScale = 4096;
+  else
+#endif
   if((iColPOC != iColRefPOC)&&(iCurrPOC != iCurrRefPOC))
     iScale = xGetDistScaleFactor(iCurrPOC, iCurrRefPOC, iColPOC, iColRefPOC);
@@ -6052,4 +6367,9 @@
   if ( iScale == 4096 )
   {
+#if VSP_MV_ZERO
+    if( uiCurRefViewId == NUM_VIEW_VSP )
+      rcMv.setZero();
+    else
+#endif
     rcMv = cColMv;
   }
@@ -6151,4 +6471,9 @@
     return false;
   }
+
+#if VSP_N //??
+  if (pColCU->isSkipped(uiPartIdxCenter))
+    return false;
+#endif
   
   if( m_pcSlice->getRefPic( eRefPicList, iRefIdx )->getViewId() != m_pcSlice->getViewId() )
@@ -7705,2 +8030,3 @@
 
 //! \}
+
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDataCU.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDataCU.h	(revision 166)
@@ -265,4 +265,8 @@
   Bool          xAddMVPCand           ( AMVPInfo* pInfo, RefPicList eRefPicList, Int iRefIdx, UInt uiPartUnitIdx, MVP_DIR eDir );
   Bool          xAddMVPCandOrder      ( AMVPInfo* pInfo, RefPicList eRefPicList, Int iRefIdx, UInt uiPartUnitIdx, MVP_DIR eDir );
+#if FORCE_REF_VSP==2
+  inline bool   xAddVspSkip(UChar ucVspMergePos, Bool bVspMvZeroDone, UInt uiDepth, Bool* abCandIsInter, Int& iCount,
+                            UChar* puhInterDirNeighbours, TComMvField* pcMvFieldNeighbours, Int mrgCandIdx);
+#endif
 
   Void          deriveRightBottomIdx        ( PartSize eCUMode, UInt uiPartIdx, UInt& ruiPartIdxRB );
@@ -656,4 +660,10 @@
   Bool          isIntra   ( UInt uiPartIdx )  { return m_pePredMode[ uiPartIdx ] == MODE_INTRA; }
   Bool          isSkipped ( UInt uiPartIdx );                                                     ///< SKIP (no residual)
+#if FORCE_REF_VSP==1
+  Int           isVspMode ( UInt uiPartIdx )  { return m_pePredMode[ uiPartIdx ] == MODE_SYNTH; }
+#elif FORCE_REF_VSP==2 
+  Int           isVspMode ( UInt uiPartIdx );
+  Int           isVspMode ( UInt uiPartIdx, TComMv cCompMv );
+#endif
   
   // -------------------------------------------------------------------------------------------------------------------
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDepthMapGenerator.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 166)
@@ -562,4 +562,12 @@
   m_cTmpPic.dump( acFilename, ( pcPic->getPOC() != 0 )  );
 }
+
+#if VSP_N
+Void
+TComDepthMapGenerator::clearDepthMap( TComPic* pcPic, Int iVal/*=PDM_UNDEFINED_DEPTH*/ )
+{
+  xClearDepthMap( pcPic, iVal );
+}
+#endif
 #endif
 
@@ -733,5 +741,8 @@
       Int         iNumRefPics       = pcSlice->getNumRefIdx( eRefPicList );
       for( Int iPdmRefIdx = 0; iPdmRefIdx < iNumRefPics; iPdmRefIdx++ )
-{
+      {
+#if VSP_N
+        if( pcSlice->getRefViewId( eRefPicList, iPdmRefIdx ) != NUM_VIEW_VSP )
+#endif
         if( pcSlice->getRefPOC( eRefPicList, iPdmRefIdx ) == pcSlice->getPOC())
         {
@@ -834,6 +845,17 @@
   Int           iRefPoc     = pcRefPic->getPOC();
   Bool          bInterview  = ( uiRefViewId < m_uiCurrViewId );
+#if VSP_N
+  Bool          bVsp        = ( pcRefPic->getViewId() == NUM_VIEW_VSP );
+  AOT(  bInterview &&  bVsp && iRefPoc != pcSlice->getPOC() );
+  AOT( !bInterview && !bVsp && iRefPoc == pcSlice->getPOC() );
+#else
   AOT(  bInterview && iRefPoc != pcSlice->getPOC() );
   AOT( !bInterview && iRefPoc == pcSlice->getPOC() );
+#endif
+
+#if FORCE_REF_VSP
+  if( bVsp ) return false;
+#endif
+
   Bool          bPdmIView   = ( ( pcSPS->getMultiviewMvPredMode() & PDM_USE_FOR_IVIEW ) == PDM_USE_FOR_IVIEW );
   Bool          bPdmInter   = ( ( pcSPS->getMultiviewMvPredMode() & PDM_USE_FOR_INTER ) == PDM_USE_FOR_INTER );
@@ -924,6 +946,16 @@
   Int           iRefPoc     = pcRefPic->getPOC();
   Bool          bInterview  = ( uiRefViewId < m_uiCurrViewId );
+#if VSP_N
+  Bool          bVsp        = ( pcRefPic->getViewId() == NUM_VIEW_VSP );
+  AOT(  bInterview &&  bVsp && iRefPoc != pcSlice->getPOC() );
+  AOT( !bInterview && !bVsp && iRefPoc == pcSlice->getPOC() );
+#else
   AOT(  bInterview && iRefPoc != pcSlice->getPOC() );
   AOT( !bInterview && iRefPoc == pcSlice->getPOC() );
+#endif
+
+#if FORCE_REF_VSP
+  if( bVsp ) return false;
+#endif
 
   Bool          bPdmIView   = ( ( pcSPS->getMultiviewMvPredMode() & PDM_USE_FOR_IVIEW ) == PDM_USE_FOR_IVIEW );
@@ -1351,4 +1383,9 @@
     xInterPredictCUDepthMap( pcSubCU, pcSubDM );
     break;
+#if FORCE_REF_VSP==1
+  case MODE_SYNTH:
+    xIntraPredictCUDepthMap( pcSubCU, pcSubDM ); //What to do? Need Fix!
+    break;
+#endif
   default:
     AOT( true );
@@ -1464,4 +1501,14 @@
                                           aiCurrRefIdx[1] >= 0 && pcCU->getSlice()->getRefPic( REF_PIC_LIST_1, aiCurrRefIdx[1] )->getSPS()->getViewId() != m_uiCurrViewId };
     Bool            bUsesInterViewPrd = ( abCurrIntView[0] || abCurrIntView[1] );
+#if VSP_N
+    if(( aiCurrRefIdx[0] >= 0 && pcCU->getSlice()->getRefPic( REF_PIC_LIST_0, aiCurrRefIdx[0] )->getViewId() == NUM_VIEW_VSP ) ||
+       ( aiCurrRefIdx[1] >= 0 && pcCU->getSlice()->getRefPic( REF_PIC_LIST_1, aiCurrRefIdx[1] )->getViewId() == NUM_VIEW_VSP )) {
+      //if refpic is VSP, copy to Original cuurent PDM
+      TComPicYuv* pcPdm = pcCU->getPic()->getPredDepthMap();
+      UInt  uiZOrderIdx = pcCU->getZorderIdxInCU() + uiAbsPartIdx;
+      assert( pcPdm );
+      pcCUDepthMap->copyFromPicYuv( pcPdm, pcCU->getAddr(), uiZOrderIdx );
+    }
+#endif
     if( bUsesInterViewPrd )
     {
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDepthMapGenerator.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDepthMapGenerator.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDepthMapGenerator.h	(revision 166)
@@ -140,4 +140,7 @@
   Void  updateDepthMap        ( TComPic*      pcPic );
   Void  dumpDepthMap          ( TComPic*      pcPic, char* pFilenameBase );
+#if VSP_N
+  Void  clearDepthMap         ( TComPic*      pcPic, Int   iVal  = PDM_UNDEFINED_DEPTH);
+#endif
 #endif
 
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComLoopFilter.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComLoopFilter.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComLoopFilter.cpp	(revision 166)
@@ -439,5 +439,9 @@
   
   //-- Set BS for Intra MB : BS = 4 or 3
-  if ( pcCUP->isIntra(uiPartP) || pcCUQ->isIntra(uiPartQ) )
+  if ( pcCUP->isIntra(uiPartP) || pcCUQ->isIntra(uiPartQ) 
+#if FORCE_REF_VSP==1
+    || pcCUP->isVspMode(uiPartP) || pcCUQ->isVspMode(uiPartQ) 
+#endif
+  )
   {
     uiBs = 2;
@@ -445,5 +449,9 @@
   
   //-- Set BS for not Intra MB : BS = 2 or 1 or 0
-  if ( !pcCUP->isIntra(uiPartP) && !pcCUQ->isIntra(uiPartQ) )
+  if ( !pcCUP->isIntra(uiPartP) && !pcCUQ->isIntra(uiPartQ) 
+#if FORCE_REF_VSP==1
+    && !pcCUP->isVspMode(uiPartP) && !pcCUQ->isVspMode(uiPartQ) 
+#endif
+  )
   {
 #if NSQT_LFFIX
@@ -542,4 +550,11 @@
   }   // enf of "if( not Intra )"
   
+#if FORCE_REF_VSP==1
+  if ( pcCUP->isVspMode(uiPartP) || pcCUQ->isVspMode(uiPartQ))
+  {
+    uiBs = 0;
+  }
+#endif
+
   m_aapucBS[iDir][uiAbsPartIdx] = uiBs;
 }
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPic.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPic.cpp	(revision 166)
@@ -53,4 +53,8 @@
   m_apcPicYuv[0]      = NULL;
   m_apcPicYuv[1]      = NULL;
+#if VSP_N
+  m_apcPicYuvAvail     = NULL;
+  m_apcPicYuvSynth     = NULL;
+#endif
 #if DEPTH_MAP_GENERATION
   m_pcPredDepthMap    = NULL;
@@ -64,4 +68,7 @@
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   m_pcResidual        = NULL;
+#endif
+#if DEBUGIMGOUT
+  m_acPicYuvDebug     = NULL;
 #endif
   m_pcPicYuvPred      = NULL;
@@ -95,5 +102,8 @@
   }
   m_apcPicYuv[1]  = new TComPicYuv;  m_apcPicYuv[1]->create( iWidth, iHeight, uiMaxWidth, uiMaxHeight, uiMaxDepth );
-  
+#if DEBUGIMGOUT
+  m_acPicYuvDebug    = new TComPicYuv;  m_acPicYuvDebug->create( iWidth, iHeight, uiMaxWidth, uiMaxHeight, uiMaxDepth );
+#endif
+
   /* there are no SEI messages associated with this picture initially */
   m_SEIs = NULL;
@@ -162,4 +172,12 @@
     delete m_pcResidual;
     m_pcResidual = NULL;
+  }
+#endif
+#if DEBUGIMGOUT
+  if (m_acPicYuvDebug)
+  {
+    m_acPicYuvDebug->destroy();
+    delete m_acPicYuvDebug;
+    m_acPicYuvDebug = NULL;
   }
 #endif
@@ -623,4 +641,59 @@
 }
 
+#if VSP_N
+Void TComPic::checkSynthesisAvailability( /*TComDataCU*& rpcCU, */UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth, Bool *&rpbCUSynthesied )
+{ 
+  rpbCUSynthesied[0] = true;
+  rpbCUSynthesied[1] = true;
+  rpbCUSynthesied[2] = true;
+  rpbCUSynthesied[3] = true;
+
+  if (!getPicYuvAvail())
+  {
+    rpbCUSynthesied[0] = false;
+    rpbCUSynthesied[1] = false;
+    rpbCUSynthesied[2] = false;
+    rpbCUSynthesied[3] = false;
+    return;    
+  }
+  
+  Int x, y;
+  Pel* pAvail  = getPicYuvAvail()->getLumaAddr ( iCuAddr, uiAbsZorderIdx );
+  Int CUHeight = g_uiMaxCUHeight >> uiPartDepth; //rpcCU->getHeight(uiAbsZorderIdx);
+  Int CUWidth  = g_uiMaxCUWidth  >> uiPartDepth; //rpcCU->getWidth(uiAbsZorderIdx);
+  
+  Int  iStride  = getPicYuvAvail()->getStride();
+  for ( y = ((CUHeight - 1) >> 1); y >= 0; y-- )
+  {
+    for ( x = ((CUWidth - 1) >> 1); x >= 0; x-- )
+    {
+      rpbCUSynthesied[0] &= (pAvail[x] != 0);
+    }
+    for ( x = CUWidth - 1; x >= ((CUWidth) >> 1); x-- )
+    {
+      rpbCUSynthesied[1] &= (pAvail[x] != 0);
+    }
+    pAvail += iStride;
+  }
+  //for ( y = CUHeight - 1; y >= ((CUHeight) >> 1); y-- )
+  for ( y = ((CUHeight - 1) >> 1); y >= 0; y-- ) //Owieczka
+  {
+    for ( x = ((CUWidth - 1) >> 1); x >= 0; x-- )
+    {
+      rpbCUSynthesied[2] &= (pAvail[x] != 0);
+    }
+    for ( x = CUWidth - 1; x >= ((CUWidth) >> 1); x-- )
+    {
+      rpbCUSynthesied[3] &= (pAvail[x] != 0);
+    }
+    pAvail += iStride;
+  }
+
+  //rpbCUSynthesied[0] = !rpbCUSynthesied[0];
+  //rpbCUSynthesied[1] = !rpbCUSynthesied[1];
+  //rpbCUSynthesied[2] = !rpbCUSynthesied[2];
+  //rpbCUSynthesied[3] = !rpbCUSynthesied[3];
+}
+#endif
 
 //! \}
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPic.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPic.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPic.h	(revision 166)
@@ -65,4 +65,9 @@
   TComPicYuv*           m_apcPicYuv[2];           //  Texture,  0:org / 1:rec
   
+#if VSP_N
+  TComPicYuv*           m_apcPicYuvAvail;         //  Availability Map - Does the given pixel can be synthesised in receiver
+  TComPicYuv*           m_apcPicYuvSynth;         //  Sythesied image
+#endif
+
 #if DEPTH_MAP_GENERATION
   TComPicYuv*           m_pcPredDepthMap;         //  estimated depth map
@@ -85,4 +90,7 @@
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   TComPicYuv*           m_pcResidual;             //  residual buffer (coded or inter-view predicted residual)
+#endif
+#if DEBUGIMGOUT
+  TComPicYuv*           m_acPicYuvDebug;          //  debug image
 #endif
 
@@ -145,4 +153,11 @@
   TComPicYuv*   getPicYuvOrg()        { return  m_apcPicYuv[0]; }
   TComPicYuv*   getPicYuvRec()        { return  m_apcPicYuv[1]; }
+#if VSP_N
+  Void          setPicYuvAvail( TComPicYuv* pc ){ m_apcPicYuvAvail = pc; }
+  Void          setPicYuvSynth( TComPicYuv* pc ){ m_apcPicYuvSynth = pc; }
+  TComPicYuv*   getPicYuvAvail()      { return  m_apcPicYuvAvail; }
+  TComPicYuv*   getPicYuvSynth()      { return  m_apcPicYuvSynth; }
+  Void          checkSynthesisAvailability(  /*TComDataCU*& rpcBestCU, */UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth, Bool *&rpbCUSynthesied);
+#endif
 #if HHI_INTERVIEW_SKIP
   TComPicYuv*   getUsedPelsMap()      { return  m_pcUsedPelsMap; }
@@ -168,4 +183,8 @@
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   TComPicYuv*   getResidual()         { return  m_pcResidual; }
+#endif
+
+#if DEBUGIMGOUT
+  TComPicYuv*   getPicYuvRecDbg()     { return  m_acPicYuvDebug; }
 #endif
 
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPicSym.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPicSym.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPicSym.cpp	(revision 166)
@@ -97,4 +97,8 @@
     m_puiInverseCUOrderMap[i] = i;
   }
+
+#if VSP_N
+  m_apcTComTile = NULL;
+#endif
 }
 
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPicYuv.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPicYuv.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPicYuv.h	(revision 166)
@@ -184,4 +184,13 @@
   Void  setChromaTo  ( Pel pVal );  
 
+#if DEBUGIMGOUT
+  // Degub tools
+public:
+  Void colsetToPicYuv   ( const UChar ucColor[3],                 Int iOffset[2][2], TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
+  Void colsetToPicLuma  ( const UChar ucLumaOffCol,               Int iOffset[2][2], TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
+  Void colsetToPicChroma( const UChar ucUCol, const UChar ucVCol, Int iOffset[2][2], TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
+  Void drawLineToPicYuv ( bool bHor, bool bVer, UInt uiSize,      TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
+#endif
+
 };// END CLASS DEFINITION TComPicYuv
 
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComResidualGenerator.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComResidualGenerator.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComResidualGenerator.cpp	(revision 166)
@@ -390,4 +390,9 @@
     xSetRecResidualInterCU( pcSubCU, pcSubRes );
     break;
+#if FORCE_REF_VSP==1
+  case MODE_SYNTH:
+    xSetRecResidualIntraCU( pcSubCU, pcSubRes ); //MayBe it should be seperate function
+    break;
+#endif
   default:
     AOT( true );
